/*
    opinionDynamics 0.3: BatchSwarm.m
    Copyright (C) 2005 by Gary McKeown
	
	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

    Contact information:
		Gary McKeown,
		School of Psychology,
		Queens University of Belfast,
		Belfast BT7 1NN,
		Northern Ireland, 
		UK.
	g.mckeown@qub.ac.uk
*/

#import "BatchSwarm.h"
#import "ModelSwarm.h"
#import <activity.h>
#import <simtoolsgui.h>
#import "Parameters.h"
#import <analysis.h>

#include <stdio.h>

@implementation BatchSwarm

+ createBegin: aZone
{
	BatchSwarm *obj;
	obj = [super createBegin: aZone];
	return obj;
}

- createEnd
{
	return [super createEnd];
}

- buildObjects
{
  id modelZone;					 
  [super buildObjects];

  modelZone = [Zone create: self];
  modelSwarm = [ModelSwarm create: modelZone];
  [modelSwarm buildObjects];

  return self;
}

- buildActions
{
  [super buildActions];

  [modelSwarm buildActions];

   
  stopSchedule = [Schedule create: self];
  [stopSchedule at:getInt ((Parameters *)arguments, "experimentDuration")
                createActionTo: self 
                message: M(stopRunning)];

  return self;
}

- activateIn: swarmContext
{
	[super activateIn: swarmContext];
	[modelSwarm activateIn: self];
	[stopSchedule activateIn: self];

	return [self getSwarmActivity];
}

- go 
{
	[[self getActivity] run];
	return [[self getActivity] getStatus];
}

- (void)drop
{
	[modelSwarm drop];
}

@end








