/*
    opinionDynamics 0.3: ExpSwarm.h
    Copyright (C) 2005 by Gary McKeown
	
	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

    Contact information:
		Gary McKeown,
		School of Psychology,
		Queens University of Belfast,
		Belfast BT7 1NN,
		Northern Ireland, 
		UK.
	g.mckeown@qub.ac.uk
*/

#import "ModelSwarm.h"
#import <objectbase/SwarmObject.h>
#import <objectbase.h>
#import <analysis.h>
#import <defobj.h> // Archiver


@interface ExperSwarm: Swarm
{
	unsigned numModelsRun;			// number of models run

	id experActions;				
	id stopSchedule;
	id experSchedule;
	
	FILE *dataExperOutputFileStdDev;
	FILE *dataExperOutputFileOpinion;
	FILE *dataExperOutputFileIndicator;
	BOOL dataFileExists;

	ModelSwarm *modelSwarm;			// the main Model

}

+ createBegin: aZone;

- buildObjects;
- buildActions;
- activateIn: swarmContext;
- checkToStop;
- stopRunning;
- go;

- (BOOL)stepParameters;
- prepareCOutputFile;
- writeCData;
- (void)drop;

@end
