/*
    opinionDynamics 0.3: ModelSwarm.m
    Copyright (C) 2005 by Gary McKeown
	
	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

    Contact information:
		Gary McKeown,
		School of Psychology,
		Queens University of Belfast,
		Belfast BT7 1NN,
		Northern Ireland, 
		UK.
	g.mckeown@qub.ac.uk
*/

#import "Person.h"
#import "OpinionWorld.h"
#import <objectbase.h>
#import <space.h>
#import <activity.h>
#import <collections.h>
#import <random.h>
#import <string.h>
#import <objectbase/Swarm.h>

@interface ModelSwarm : Swarm {

	id modelActions;
	id modelSchedule;
	id opinionAverager;
	
	id <RandomBitDist> randomBit;

	id <List> agentList;
	id <List> sampleList;
	id world;
	
	id aNormalDist;
	
	id <Map> clusterList;
	id output;
	FILE *dataObserverOutputFileOpinion;
	BOOL dataFileExists;
}
	
- createEnd;

- buildObjects;
- buildActions;
- stepThroughList;

- (BOOL)randomizeList;

- activateIn: swarmContext;
- getAgentList;
- getWorld;

- (double)getStandardDeviation;
- (double)getMeanOpinion;
- (double)getIndicator;

- writeStepData:(double)opinion;
- prepareCDataFile;
- listEnd;
- doEndStats;

- checkToStop;
- stopRunning;
- (void)drop;

@end
