/*
    opinionDynamics 0.3: ObserverSwarm.m
    Copyright (C) 2005 by Gary McKeown
	
	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

    Contact information:
		Gary McKeown,
		School of Psychology,
		Queens University of Belfast,
		Belfast BT7 1NN,
		Northern Ireland, 
		UK.
	g.mckeown@qub.ac.uk
*/

#import <objectbase.h>
#import <simtoolsgui.h>
#import <simtoolsgui/GUISwarm.h>
#import <space.h>
#import <activity.h>
#import <analysis.h>
#import <collections.h>
#import <simtools.h>
#import "ModelSwarm.h"

@interface ObserverSwarm : GUISwarm {
	int displayFrequency;				

	id displayActions;				
	id displaySchedule;
	id stopSchedule;
	
	long currentTime;

	ModelSwarm * modelSwarm;	 
	id <Colormap> colormap;
	id <ZoomRaster> worldRaster;
	id <Object2dDisplay> worldDisplay;
	id <EZGraph> meanGraph;
	id <EZGraph> stdDevGraph;
	id <EZGraph> indicatorGraph;
}

+ createBegin: (id) aZone;
- createEnd;
- buildObjects;
- buildActions;
- activateIn: (id) swarmContext;
- stopRunning;
- takeScreenShot;
- eraseRaster;

- (void)drop;

@end
