/*
    opinionDynamics 0.3: OpinionWorld.h
    Copyright (C) 2005 by Gary McKeown
	
	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

    Contact information:
		Gary McKeown,
		School of Psychology,
		Queens University of Belfast,
		Belfast BT7 1NN,
		Northern Ireland, 
		UK.
	g.mckeown@qub.ac.uk
*/

#import <objectbase.h>
#import <objectbase/SwarmObject.h>
#import <space.h>  //for Discrete2d

@interface OpinionWorld: SwarmObject  
{
  id modelSwarm; 
  unsigned int xsize, ysize;
  id <Discrete2d> objectGrid;
}

- (int)wrapCoord: (int)inCoord atModulus: (int)inModulus;
- (int)wrapXCoord: (int)inCoord;
- (int)wrapYCoord: (int)inCoord;
- setSizeX: (unsigned)x Y: (unsigned)y;
- createObjectGridX: (unsigned) x Y: (unsigned) y;
- getObjectGrid;
- (void)setModelSwarm: m;
- (id)getModelSwarm;

- createEnd;
- addObject: aPerson atX: (int)x Y: (int)y;
- (double)getOpinionAtX: (int)x Y: (int)y;
- (void)setOpinion:(double)newOpinion atX: (int)x Y: (int)y;
- (id)returnObjectAtX: (int)x Y: (int)y;

@end
