/*
    opinionDynamics 0.3: OpinionWorld.m
    Copyright (C) 2005 by Gary McKeown
	
	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

    Contact information:
		Gary McKeown,
		School of Psychology,
		Queens University of Belfast,
		Belfast BT7 1NN,
		Northern Ireland, 
		UK.
	g.mckeown@qub.ac.uk
*/

#import "OpinionWorld.h"
#import "Person.h"
#import "ModelSwarm.h"
#import "Parameters.h"
#import <space.h>


@implementation OpinionWorld

- (int)wrapCoord: (int)inCoord atModulus: (int)inModulus
{
  if (inCoord < 0 || inCoord >= inModulus)
    { 
      inCoord = (inCoord + inModulus) % inModulus; 
    }
  return inCoord;
}

- (int)wrapXCoord: (int)inCoord
{
  return [self wrapCoord: inCoord atModulus: xsize];
}

- (int)wrapYCoord: (int)inCoord
{
  return [self wrapCoord: inCoord atModulus: ysize];
}

- setSizeX: (unsigned)x Y: (unsigned)y
{
  xsize = x;
  ysize = y;

  return self;
}

- createObjectGridX: (unsigned) x Y: (unsigned) y
{
  id aGrid;
  aGrid = [Discrete2d createBegin: [self getZone]];
  [aGrid setSizeX: x Y: y];
  aGrid = [aGrid createEnd];
  return aGrid;
}

- getObjectGrid
{
  return objectGrid;
}

- (void)setModelSwarm: m 
{
	modelSwarm=m;
}
- (id)getModelSwarm
{
	return modelSwarm;
}

- createEnd
{
  objectGrid = [self createObjectGridX: xsize Y: ysize];
  return [super createEnd];
}

- addObject: aPerson atX: (int)x Y: (int)y
{
	[objectGrid putObject: aPerson atX: x Y: y];
	return self;
}

- (double)getOpinionAtX: (int)x Y: (int)y
{
	return [[objectGrid getObjectAtX: x Y: y] getOpinion];
}

- (void)setOpinion:(double)newOpinion atX: (int)x Y: (int)y
{
	[[objectGrid getObjectAtX: x Y: y] setOpinion:newOpinion];
}

- (id)returnObjectAtX: (int)x Y: (int)y
{
	return [objectGrid getObjectAtX: x Y: y];
}

@end

