/*
    opinionDynamics 0.3: Parameters.m
    Copyright (C) 2005 by Gary McKeown
	
	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

    Contact information:
		Gary McKeown,
		School of Psychology,
		Queens University of Belfast,
		Belfast BT7 1NN,
		Northern Ireland, 
		UK.
	g.mckeown@qub.ac.uk
*/
#import <defobj/Arguments.h>

id
makeProbe (id obj, const char *ivarName);

int
getInt (id obj, const char *ivarName);



@interface Parameters: Arguments_c
{
	int worldSize;
	double convergence, threshold;
	int broadcastRatio;
	double polarisation;
	double minOpinion, maxOpinion;
	
	double thresholdInc;
	double polarisationInc;
	int broadcastRatioInc;
	BOOL polarisationPresent;

	unsigned randomSeed;
	BOOL randomize;
	BOOL collectData;
	
	int run, experimentDuration;
	long currentTime;
}

-init;


- (int)parseKey: (int) key arg: (const char*) arg;

- (double)threshold;
- (void)setThreshold:(double)newThreshold;
- (double)convergence;
- (double)polarisation;
- (void)setPolarisation:(double)newPolarisation;
- (int)broadcastRatio;
- (void)setBroadcastRatio:(int)newBroadcastRatio;
- (double)thresholdInc;
- (void)setThresholdInc:(double)newThresholdInc;
- (double)polarisationInc;
- (void)setPolarisationInc:(double)newPolarisationInc;
- (int)broadcastRatioInc;
- (void)setBroadcastRatioInc:(int)newBroadcastRatioInc;
- (BOOL)polarisationPresent;
- (void)setPolarisationPresent:(BOOL)newPolarisationPresent;
- (double)minOpinion;
- (void)setMinOpinion:(double)newMinOpinion;
- (double)maxOpinion;
- (void)setMaxOpinion:(double)newMaxOpinion;

- (int)worldSize;
- (BOOL)randomize;
- (BOOL)collectData;
- (void)setRandomize:(BOOL)newRandomize;

- (void)setCurrentTime: (long)x;

- (timeval_t)getCurrentTime;
- (void)incrementThreshold;
- (void)incrementPolarisation;

@end




