/*
    opinionDynamics 0.3: Person.h
    Copyright (C) 2005 by Gary McKeown
	
	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

    Contact information:
		Gary McKeown,
		School of Psychology,
		Queens University of Belfast,
		Belfast BT7 1NN,
		Northern Ireland, 
		UK.
	g.mckeown@qub.ac.uk
*/

#import <objectbase.h>
#import <objectbase/SwarmObject.h>
#import <space.h>
#import <activity.h>
#import <collections.h>
#import <random.h>
#import "OpinionWorld.h"


@interface Person: SwarmObject {
	int x, y;
	int xsize,ysize;
	int myColor;
	double opinion;
	double personalConvergence, personalThreshold;
	
	id <List> neighbourList;

	int idNumber;
	OpinionWorld * myWorld;
}
	
- createEnd;

- setX: (int)inx Y: (int)iny;

- (int)getX;
- (int)getY;

- (void)setPersonalConvergence: (double)convergence;
- (void)setPersonalThreshold: (double)threshold;
- setWorld: w;
- setColor: (int)c;
- (int)getColor;

- (void)setIDNumber: (int)numb;
- (int)idNumber;

- step;
- stepBroadcast:(double)broadcastOpinion;
- (Person *)getNeighbour;

- drawSelfOn: (id)rast;
				
- (double)getOpinion;
- setOpinion:(double)newOpinion;
- (double)getRoundedOpinion;

- (int)wrapXCoord: (int)inCoord;
- (int)wrapYCoord: (int)inCoord;
- (int)wrapCoord: (int)inCoord atModulus: (int)inModulus;

- (int)compare:(Person *)otherPerson;
- (int)compare:(Person *)otherPerson withRange:(double)range;
@end

