/*
    opinionDynamics 0.2: main.m
    Copyright (C) 2005 by Gary McKeown
	
	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.

    Contact information:
		Gary McKeown,
		School of Psychology,
		Queens University of Belfast,
		Belfast BT7 1NN,
		Northern Ireland, 
		UK.
	g.mckeown@qub.ac.uk
*/

#import "ObserverSwarm.h"
#import "BatchSwarm.h"
#import "Parameters.h"
#import "ExperSwarm.h"

int
main(int argc,const char ** argv) {

	id theTopLevelSwarm;
	id topLevelActivity;
	initSwarmArguments (argc, argv, [Parameters class]);
	
	// Make the bug observer swarm if swarmGUIMode equals YES
	if (swarmGUIMode == YES)
	{
		theTopLevelSwarm = [ObserverSwarm createBegin: globalZone];
		//now run the init method of the arguments object (Parameters class)
		SET_WINDOW_GEOMETRY_RECORD_NAME (theTopLevelSwarm);
		theTopLevelSwarm = [theTopLevelSwarm createEnd];
		[(id) arguments init];
		CREATE_ARCHIVED_PROBE_DISPLAY (arguments);
	  
	} else {
		theTopLevelSwarm =  [ExperSwarm create: globalZone];
	}

	[theTopLevelSwarm buildObjects];
	[theTopLevelSwarm buildActions];
	topLevelActivity = [theTopLevelSwarm activateIn: nil];
	
	[theTopLevelSwarm go];

	[topLevelActivity drop];
	[theTopLevelSwarm drop];

	return 0;
}
